#import "ViewController.h"
#import "Diagram.h"
#import "DiagramNode.h"

@interface ViewController ()

@end

@implementation ViewController
{
    NSArray* sampleFiles;
    int fileCounter;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	
    fileCounter = 0;
    sampleFiles = [[NSArray alloc] initWithObjects:
        @"flowchart",
        @"database",
        @"rotation",
        @"spanning_cells",
        @"all_shapes",
        @"treenodes",
        nil];
    
    [self nextDiagram:self];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
    } else {
        return YES;
    }
}

- (IBAction)nextDiagram:(id)sender
{
    NSString* fileName = [sampleFiles objectAtIndex:fileCounter++];
    if (fileCounter == [sampleFiles count])
        fileCounter = 0;
    
    NSBundle* appBundle = [NSBundle mainBundle];
    NSString* filePath = [appBundle pathForResource:fileName ofType:@"xml"];

    Diagram* diagram = [[Diagram alloc] init];
    [diagram loadFromXml:filePath];
    [diagramView setDiagram:diagram];
    
    scrollView.contentSize = diagramView.frame.size;
}


- (void)diagramTouched:(id)sender atPoint:(CGPoint)point
{
    DiagramItem* item = [[diagramView diagram] getItemAt:point];
    if ([item isKindOfClass:[DiagramNode class]])
    {
        DiagramNode* node = (DiagramNode*)item;
        UIAlertView *errorAlert = [[UIAlertView alloc]
            initWithTitle:@"Node tapped"
            message:[node text]
            delegate:nil
            cancelButtonTitle:@"OK"
            otherButtonTitles:nil];
        [errorAlert show];

    }
}

@end
